# .GitLab-CI.yml keyword reference: https://docs.gitlab.com/ee/ci/yaml/
# image to run .NET-core builds and applications:
# image: mcr.microsoft.com/dotnet/core/sdk:3.1

image: mcr.microsoft.com/dotnet/core/sdk:3.1

# Define the stages of the pipeline
stages:
  - build
  - test
  - deploy

# Cache dependencies to speed up builds
cache:
  paths:
    - node_modules/
    - .cache/

# Build Stage
build_job:
  stage: build
  script:
    - dotnet restore
    - dotnet build -c Release
  artifacts:
    paths:
      - ./**/dotnetcore-sample.dll

# Test Stage
test_job:
  stage: test
  script:
    - dotnet test -c Release

# Deploy Stage
deploy_job:
  stage: deploy
  script:
    - dotnet publish -c Release -o /app
  environment:
    name: production
  only:
    - master
  dependencies:
    - build_job